*** /dev/null
--- b/src/include/access/heapam_xlog.h
***************
*** 0 ****
--- 1,264 ----
+ /*-------------------------------------------------------------------------
+  *
+  * heapam_xlog.h
+  *	  POSTGRES heap access XLOG definitions.
+  *
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  * src/include/access/heapam_xlog.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef HEAPAM_XLOG_H
+ #define HEAPAM_XLOG_H
+ 
+ #include "access/htup.h"
+ #include "access/xlog.h"
+ #include "storage/relfilenode.h"
+ #include "utils/relcache.h"
+ 
+ 
+ /*
+  * WAL record definitions for heapam.c's WAL operations
+  *
+  * XLOG allows to store some information in high 4 bits of log
+  * record xl_info field.  We use 3 for opcode and one for init bit.
+  */
+ #define XLOG_HEAP_INSERT		0x00
+ #define XLOG_HEAP_DELETE		0x10
+ #define XLOG_HEAP_UPDATE		0x20
+ /* 0x030 is free, was XLOG_HEAP_MOVE */
+ #define XLOG_HEAP_HOT_UPDATE	0x40
+ #define XLOG_HEAP_NEWPAGE		0x50
+ #define XLOG_HEAP_LOCK			0x60
+ #define XLOG_HEAP_INPLACE		0x70
+ 
+ #define XLOG_HEAP_OPMASK		0x70
+ /*
+  * When we insert 1st item on new page in INSERT, UPDATE, HOT_UPDATE,
+  * or MULTI_INSERT, we can (and we do) restore entire page in redo
+  */
+ #define XLOG_HEAP_INIT_PAGE		0x80
+ /*
+  * We ran out of opcodes, so heapam.c now has a second RmgrId.	These opcodes
+  * are associated with RM_HEAP2_ID, but are not logically different from
+  * the ones above associated with RM_HEAP_ID.  XLOG_HEAP_OPMASK applies to
+  * these, too.
+  */
+ #define XLOG_HEAP2_FREEZE		0x00
+ #define XLOG_HEAP2_CLEAN		0x10
+ /* 0x20 is free, was XLOG_HEAP2_CLEAN_MOVE */
+ #define XLOG_HEAP2_CLEANUP_INFO 0x30
+ #define XLOG_HEAP2_VISIBLE		0x40
+ #define XLOG_HEAP2_MULTI_INSERT 0x50
+ 
+ /*
+  * All what we need to find changed tuple
+  *
+  * NB: on most machines, sizeof(xl_heaptid) will include some trailing pad
+  * bytes for alignment.  We don't want to store the pad space in the XLOG,
+  * so use SizeOfHeapTid for space calculations.  Similar comments apply for
+  * the other xl_FOO structs.
+  */
+ typedef struct xl_heaptid
+ {
+ 	RelFileNode node;
+ 	ItemPointerData tid;		/* changed tuple id */
+ } xl_heaptid;
+ 
+ #define SizeOfHeapTid		(offsetof(xl_heaptid, tid) + SizeOfIptrData)
+ 
+ /* This is what we need to know about delete */
+ typedef struct xl_heap_delete
+ {
+ 	xl_heaptid	target;			/* deleted tuple id */
+ 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
+ } xl_heap_delete;
+ 
+ #define SizeOfHeapDelete	(offsetof(xl_heap_delete, all_visible_cleared) + sizeof(bool))
+ 
+ /*
+  * We don't store the whole fixed part (HeapTupleHeaderData) of an inserted
+  * or updated tuple in WAL; we can save a few bytes by reconstructing the
+  * fields that are available elsewhere in the WAL record, or perhaps just
+  * plain needn't be reconstructed.  These are the fields we must store.
+  * NOTE: t_hoff could be recomputed, but we may as well store it because
+  * it will come for free due to alignment considerations.
+  */
+ typedef struct xl_heap_header
+ {
+ 	uint16		t_infomask2;
+ 	uint16		t_infomask;
+ 	uint8		t_hoff;
+ } xl_heap_header;
+ 
+ #define SizeOfHeapHeader	(offsetof(xl_heap_header, t_hoff) + sizeof(uint8))
+ 
+ /* This is what we need to know about insert */
+ typedef struct xl_heap_insert
+ {
+ 	xl_heaptid	target;			/* inserted tuple id */
+ 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
+ 	/* xl_heap_header & TUPLE DATA FOLLOWS AT END OF STRUCT */
+ } xl_heap_insert;
+ 
+ #define SizeOfHeapInsert	(offsetof(xl_heap_insert, all_visible_cleared) + sizeof(bool))
+ 
+ /*
+  * This is what we need to know about a multi-insert. The record consists of
+  * xl_heap_multi_insert header, followed by a xl_multi_insert_tuple and tuple
+  * data for each tuple. 'offsets' array is omitted if the whole page is
+  * reinitialized (XLOG_HEAP_INIT_PAGE)
+  */
+ typedef struct xl_heap_multi_insert
+ {
+ 	RelFileNode node;
+ 	BlockNumber blkno;
+ 	bool		all_visible_cleared;
+ 	uint16		ntuples;
+ 	OffsetNumber offsets[1];
+ 
+ 	/* TUPLE DATA (xl_multi_insert_tuples) FOLLOW AT END OF STRUCT */
+ } xl_heap_multi_insert;
+ 
+ #define SizeOfHeapMultiInsert	offsetof(xl_heap_multi_insert, offsets)
+ 
+ typedef struct xl_multi_insert_tuple
+ {
+ 	uint16		datalen;		/* size of tuple data that follows */
+ 	uint16		t_infomask2;
+ 	uint16		t_infomask;
+ 	uint8		t_hoff;
+ 	/* TUPLE DATA FOLLOWS AT END OF STRUCT */
+ } xl_multi_insert_tuple;
+ 
+ #define SizeOfMultiInsertTuple	(offsetof(xl_multi_insert_tuple, t_hoff) + sizeof(uint8))
+ 
+ /* This is what we need to know about update|hot_update */
+ typedef struct xl_heap_update
+ {
+ 	xl_heaptid	target;			/* deleted tuple id */
+ 	ItemPointerData newtid;		/* new inserted tuple id */
+ 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
+ 	bool		new_all_visible_cleared;		/* same for the page of newtid */
+ 	/* NEW TUPLE xl_heap_header AND TUPLE DATA FOLLOWS AT END OF STRUCT */
+ } xl_heap_update;
+ 
+ #define SizeOfHeapUpdate	(offsetof(xl_heap_update, new_all_visible_cleared) + sizeof(bool))
+ 
+ /*
+  * This is what we need to know about vacuum page cleanup/redirect
+  *
+  * The array of OffsetNumbers following the fixed part of the record contains:
+  *	* for each redirected item: the item offset, then the offset redirected to
+  *	* for each now-dead item: the item offset
+  *	* for each now-unused item: the item offset
+  * The total number of OffsetNumbers is therefore 2*nredirected+ndead+nunused.
+  * Note that nunused is not explicitly stored, but may be found by reference
+  * to the total record length.
+  */
+ typedef struct xl_heap_clean
+ {
+ 	RelFileNode node;
+ 	BlockNumber block;
+ 	TransactionId latestRemovedXid;
+ 	uint16		nredirected;
+ 	uint16		ndead;
+ 	/* OFFSET NUMBERS FOLLOW */
+ } xl_heap_clean;
+ 
+ #define SizeOfHeapClean (offsetof(xl_heap_clean, ndead) + sizeof(uint16))
+ 
+ /*
+  * Cleanup_info is required in some cases during a lazy VACUUM.
+  * Used for reporting the results of HeapTupleHeaderAdvanceLatestRemovedXid()
+  * see vacuumlazy.c for full explanation
+  */
+ typedef struct xl_heap_cleanup_info
+ {
+ 	RelFileNode node;
+ 	TransactionId latestRemovedXid;
+ } xl_heap_cleanup_info;
+ 
+ #define SizeOfHeapCleanupInfo (sizeof(xl_heap_cleanup_info))
+ 
+ /* This is for replacing a page's contents in toto */
+ /* NB: this is used for indexes as well as heaps */
+ typedef struct xl_heap_newpage
+ {
+ 	RelFileNode node;
+ 	ForkNumber	forknum;
+ 	BlockNumber blkno;			/* location of new page */
+ 	/* entire page contents follow at end of record */
+ } xl_heap_newpage;
+ 
+ #define SizeOfHeapNewpage	(offsetof(xl_heap_newpage, blkno) + sizeof(BlockNumber))
+ 
+ /* This is what we need to know about lock */
+ typedef struct xl_heap_lock
+ {
+ 	xl_heaptid	target;			/* locked tuple id */
+ 	TransactionId locking_xid;	/* might be a MultiXactId not xid */
+ 	bool		xid_is_mxact;	/* is it? */
+ 	bool		shared_lock;	/* shared or exclusive row lock? */
+ } xl_heap_lock;
+ 
+ #define SizeOfHeapLock	(offsetof(xl_heap_lock, shared_lock) + sizeof(bool))
+ 
+ /* This is what we need to know about in-place update */
+ typedef struct xl_heap_inplace
+ {
+ 	xl_heaptid	target;			/* updated tuple id */
+ 	/* TUPLE DATA FOLLOWS AT END OF STRUCT */
+ } xl_heap_inplace;
+ 
+ #define SizeOfHeapInplace	(offsetof(xl_heap_inplace, target) + SizeOfHeapTid)
+ 
+ /* This is what we need to know about tuple freezing during vacuum */
+ typedef struct xl_heap_freeze
+ {
+ 	RelFileNode node;
+ 	BlockNumber block;
+ 	TransactionId cutoff_xid;
+ 	/* TUPLE OFFSET NUMBERS FOLLOW AT THE END */
+ } xl_heap_freeze;
+ 
+ #define SizeOfHeapFreeze (offsetof(xl_heap_freeze, cutoff_xid) + sizeof(TransactionId))
+ 
+ /* This is what we need to know about setting a visibility map bit */
+ typedef struct xl_heap_visible
+ {
+ 	RelFileNode node;
+ 	BlockNumber block;
+ 	TransactionId cutoff_xid;
+ } xl_heap_visible;
+ 
+ #define SizeOfHeapVisible (offsetof(xl_heap_visible, cutoff_xid) + sizeof(TransactionId))
+ 
+ extern void HeapTupleHeaderAdvanceLatestRemovedXid(HeapTupleHeader tuple,
+ 									   TransactionId *latestRemovedXid);
+ 
+ extern void heap_redo(XLogRecPtr lsn, XLogRecord *rptr);
+ extern void heap_desc(StringInfo buf, uint8 xl_info, char *rec);
+ extern void heap2_redo(XLogRecPtr lsn, XLogRecord *rptr);
+ extern void heap2_desc(StringInfo buf, uint8 xl_info, char *rec);
+ 
+ extern XLogRecPtr log_heap_cleanup_info(RelFileNode rnode,
+ 					  TransactionId latestRemovedXid);
+ extern XLogRecPtr log_heap_clean(Relation reln, Buffer buffer,
+ 			   OffsetNumber *redirected, int nredirected,
+ 			   OffsetNumber *nowdead, int ndead,
+ 			   OffsetNumber *nowunused, int nunused,
+ 			   TransactionId latestRemovedXid);
+ extern XLogRecPtr log_heap_freeze(Relation reln, Buffer buffer,
+ 				TransactionId cutoff_xid,
+ 				OffsetNumber *offsets, int offcnt);
+ extern XLogRecPtr log_heap_visible(RelFileNode rnode, BlockNumber block,
+ 				 Buffer vm_buffer, TransactionId cutoff_xid);
+ extern XLogRecPtr log_newpage(RelFileNode *rnode, ForkNumber forkNum,
+ 			BlockNumber blk, Page page);
+ extern XLogRecPtr log_newpage_buffer(Buffer buffer);
+ 
+ #endif   /* HEAPAM_XLOG_H */
*** a/src/include/access/hio.h
--- b/src/include/access/hio.h
***************
*** 15,21 ****
  #define HIO_H
  
  #include "access/heapam.h"
! #include "access/htup.h"
  #include "utils/relcache.h"
  #include "storage/buf.h"
  
--- 15,21 ----
  #define HIO_H
  
  #include "access/heapam.h"
! #include "access/tupbasics.h"
  #include "utils/relcache.h"
  #include "storage/buf.h"
  
*** a/src/include/access/htup.h
--- b/src/include/access/htup.h
***************
*** 14,24 ****
  #ifndef HTUP_H
  #define HTUP_H
  
  #include "access/tupdesc.h"
  #include "access/tupmacs.h"
  #include "storage/bufpage.h"
- #include "storage/itemptr.h"
- #include "storage/relfilenode.h"
  
  /*
   * MaxTupleAttributeNumber limits the number of (user) columns in a tuple.
--- 14,23 ----
  #ifndef HTUP_H
  #define HTUP_H
  
+ #include "access/tupbasics.h"
  #include "access/tupdesc.h"
  #include "access/tupmacs.h"
  #include "storage/bufpage.h"
  
  /*
   * MaxTupleAttributeNumber limits the number of (user) columns in a tuple.
***************
*** 130,136 **** typedef struct DatumTupleFields
  	 */
  } DatumTupleFields;
  
! typedef struct HeapTupleHeaderData
  {
  	union
  	{
--- 129,135 ----
  	 */
  } DatumTupleFields;
  
! struct HeapTupleHeaderData
  {
  	union
  	{
***************
*** 153,161 **** typedef struct HeapTupleHeaderData
  	bits8		t_bits[1];		/* bitmap of NULLs -- VARIABLE LENGTH */
  
  	/* MORE DATA FOLLOWS AT END OF STRUCT */
! } HeapTupleHeaderData;
! 
! typedef HeapTupleHeaderData *HeapTupleHeader;
  
  /*
   * information stored in t_infomask:
--- 152,159 ----
  	bits8		t_bits[1];		/* bitmap of NULLs -- VARIABLE LENGTH */
  
  	/* MORE DATA FOLLOWS AT END OF STRUCT */
! };
! /* typedef appears in tupbasics.h */
  
  /*
   * information stored in t_infomask:
***************
*** 425,431 **** do { \
   * tuples inside the executor, in places where transaction status information
   * is not required, the tuple rowtype is known, and shaving off a few bytes
   * is worthwhile because we need to store many tuples.	The representation
-  * is chosen so that tuple access routines can work with either full or
   * minimal tuples via a HeapTupleData pointer structure.  The access routines
   * see no difference, except that they must not access the transaction status
   * or t_ctid fields because those aren't there.
--- 423,428 ----
***************
*** 458,464 **** do { \
  #define MINIMAL_TUPLE_DATA_OFFSET \
  	offsetof(MinimalTupleData, t_infomask2)
  
! typedef struct MinimalTupleData
  {
  	uint32		t_len;			/* actual length of minimal tuple */
  
--- 455,461 ----
  #define MINIMAL_TUPLE_DATA_OFFSET \
  	offsetof(MinimalTupleData, t_infomask2)
  
! struct MinimalTupleData
  {
  	uint32		t_len;			/* actual length of minimal tuple */
  
***************
*** 477,530 **** typedef struct MinimalTupleData
  	bits8		t_bits[1];		/* bitmap of NULLs -- VARIABLE LENGTH */
  
  	/* MORE DATA FOLLOWS AT END OF STRUCT */
! } MinimalTupleData;
! 
! typedef MinimalTupleData *MinimalTuple;
! 
! 
! /*
!  * HeapTupleData is an in-memory data structure that points to a tuple.
!  *
!  * There are several ways in which this data structure is used:
!  *
!  * * Pointer to a tuple in a disk buffer: t_data points directly into the
!  *	 buffer (which the code had better be holding a pin on, but this is not
!  *	 reflected in HeapTupleData itself).
!  *
!  * * Pointer to nothing: t_data is NULL.  This is used as a failure indication
!  *	 in some functions.
!  *
!  * * Part of a palloc'd tuple: the HeapTupleData itself and the tuple
!  *	 form a single palloc'd chunk.  t_data points to the memory location
!  *	 immediately following the HeapTupleData struct (at offset HEAPTUPLESIZE).
!  *	 This is the output format of heap_form_tuple and related routines.
!  *
!  * * Separately allocated tuple: t_data points to a palloc'd chunk that
!  *	 is not adjacent to the HeapTupleData.	(This case is deprecated since
!  *	 it's difficult to tell apart from case #1.  It should be used only in
!  *	 limited contexts where the code knows that case #1 will never apply.)
!  *
!  * * Separately allocated minimal tuple: t_data points MINIMAL_TUPLE_OFFSET
!  *	 bytes before the start of a MinimalTuple.	As with the previous case,
!  *	 this can't be told apart from case #1 by inspection; code setting up
!  *	 or destroying this representation has to know what it's doing.
!  *
!  * t_len should always be valid, except in the pointer-to-nothing case.
!  * t_self and t_tableOid should be valid if the HeapTupleData points to
!  * a disk buffer, or if it represents a copy of a tuple on disk.  They
!  * should be explicitly set invalid in manufactured tuples.
!  */
! typedef struct HeapTupleData
! {
! 	uint32		t_len;			/* length of *t_data */
! 	ItemPointerData t_self;		/* SelfItemPointer */
! 	Oid			t_tableOid;		/* table the tuple came from */
! 	HeapTupleHeader t_data;		/* -> tuple header and data */
! } HeapTupleData;
! 
! typedef HeapTupleData *HeapTuple;
  
- #define HEAPTUPLESIZE	MAXALIGN(sizeof(HeapTupleData))
  
  /*
   * GETSTRUCT - given a HeapTuple pointer, return address of the user data
--- 474,482 ----
  	bits8		t_bits[1];		/* bitmap of NULLs -- VARIABLE LENGTH */
  
  	/* MORE DATA FOLLOWS AT END OF STRUCT */
! };
! /* typedef appears in tupbasics.h */
  
  
  /*
   * GETSTRUCT - given a HeapTuple pointer, return address of the user data
***************
*** 534,540 **** typedef HeapTupleData *HeapTuple;
  /*
   * Accessor macros to be used with HeapTuple pointers.
   */
- #define HeapTupleIsValid(tuple) PointerIsValid(tuple)
  
  #define HeapTupleHasNulls(tuple) \
  		(((tuple)->t_data->t_infomask & HEAP_HASNULL) != 0)
--- 486,491 ----
***************
*** 575,801 **** typedef HeapTupleData *HeapTuple;
  #define HeapTupleSetOid(tuple, oid) \
  		HeapTupleHeaderSetOid((tuple)->t_data, (oid))
  
- 
- /*
-  * WAL record definitions for heapam.c's WAL operations
-  *
-  * XLOG allows to store some information in high 4 bits of log
-  * record xl_info field.  We use 3 for opcode and one for init bit.
-  */
- #define XLOG_HEAP_INSERT		0x00
- #define XLOG_HEAP_DELETE		0x10
- #define XLOG_HEAP_UPDATE		0x20
- /* 0x030 is free, was XLOG_HEAP_MOVE */
- #define XLOG_HEAP_HOT_UPDATE	0x40
- #define XLOG_HEAP_NEWPAGE		0x50
- #define XLOG_HEAP_LOCK			0x60
- #define XLOG_HEAP_INPLACE		0x70
- 
- #define XLOG_HEAP_OPMASK		0x70
- /*
-  * When we insert 1st item on new page in INSERT, UPDATE, HOT_UPDATE,
-  * or MULTI_INSERT, we can (and we do) restore entire page in redo
-  */
- #define XLOG_HEAP_INIT_PAGE		0x80
- /*
-  * We ran out of opcodes, so heapam.c now has a second RmgrId.	These opcodes
-  * are associated with RM_HEAP2_ID, but are not logically different from
-  * the ones above associated with RM_HEAP_ID.  XLOG_HEAP_OPMASK applies to
-  * these, too.
-  */
- #define XLOG_HEAP2_FREEZE		0x00
- #define XLOG_HEAP2_CLEAN		0x10
- /* 0x20 is free, was XLOG_HEAP2_CLEAN_MOVE */
- #define XLOG_HEAP2_CLEANUP_INFO 0x30
- #define XLOG_HEAP2_VISIBLE		0x40
- #define XLOG_HEAP2_MULTI_INSERT 0x50
- 
- /*
-  * All what we need to find changed tuple
-  *
-  * NB: on most machines, sizeof(xl_heaptid) will include some trailing pad
-  * bytes for alignment.  We don't want to store the pad space in the XLOG,
-  * so use SizeOfHeapTid for space calculations.  Similar comments apply for
-  * the other xl_FOO structs.
-  */
- typedef struct xl_heaptid
- {
- 	RelFileNode node;
- 	ItemPointerData tid;		/* changed tuple id */
- } xl_heaptid;
- 
- #define SizeOfHeapTid		(offsetof(xl_heaptid, tid) + SizeOfIptrData)
- 
- /* This is what we need to know about delete */
- typedef struct xl_heap_delete
- {
- 	xl_heaptid	target;			/* deleted tuple id */
- 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
- } xl_heap_delete;
- 
- #define SizeOfHeapDelete	(offsetof(xl_heap_delete, all_visible_cleared) + sizeof(bool))
- 
- /*
-  * We don't store the whole fixed part (HeapTupleHeaderData) of an inserted
-  * or updated tuple in WAL; we can save a few bytes by reconstructing the
-  * fields that are available elsewhere in the WAL record, or perhaps just
-  * plain needn't be reconstructed.  These are the fields we must store.
-  * NOTE: t_hoff could be recomputed, but we may as well store it because
-  * it will come for free due to alignment considerations.
-  */
- typedef struct xl_heap_header
- {
- 	uint16		t_infomask2;
- 	uint16		t_infomask;
- 	uint8		t_hoff;
- } xl_heap_header;
- 
- #define SizeOfHeapHeader	(offsetof(xl_heap_header, t_hoff) + sizeof(uint8))
- 
- /* This is what we need to know about insert */
- typedef struct xl_heap_insert
- {
- 	xl_heaptid	target;			/* inserted tuple id */
- 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
- 	/* xl_heap_header & TUPLE DATA FOLLOWS AT END OF STRUCT */
- } xl_heap_insert;
- 
- #define SizeOfHeapInsert	(offsetof(xl_heap_insert, all_visible_cleared) + sizeof(bool))
- 
- /*
-  * This is what we need to know about a multi-insert. The record consists of
-  * xl_heap_multi_insert header, followed by a xl_multi_insert_tuple and tuple
-  * data for each tuple. 'offsets' array is omitted if the whole page is
-  * reinitialized (XLOG_HEAP_INIT_PAGE)
-  */
- typedef struct xl_heap_multi_insert
- {
- 	RelFileNode node;
- 	BlockNumber blkno;
- 	bool		all_visible_cleared;
- 	uint16		ntuples;
- 	OffsetNumber offsets[1];
- 
- 	/* TUPLE DATA (xl_multi_insert_tuples) FOLLOW AT END OF STRUCT */
- } xl_heap_multi_insert;
- 
- #define SizeOfHeapMultiInsert	offsetof(xl_heap_multi_insert, offsets)
- 
- typedef struct xl_multi_insert_tuple
- {
- 	uint16		datalen;		/* size of tuple data that follows */
- 	uint16		t_infomask2;
- 	uint16		t_infomask;
- 	uint8		t_hoff;
- 	/* TUPLE DATA FOLLOWS AT END OF STRUCT */
- } xl_multi_insert_tuple;
- 
- #define SizeOfMultiInsertTuple	(offsetof(xl_multi_insert_tuple, t_hoff) + sizeof(uint8))
- 
- /* This is what we need to know about update|hot_update */
- typedef struct xl_heap_update
- {
- 	xl_heaptid	target;			/* deleted tuple id */
- 	ItemPointerData newtid;		/* new inserted tuple id */
- 	bool		all_visible_cleared;	/* PD_ALL_VISIBLE was cleared */
- 	bool		new_all_visible_cleared;		/* same for the page of newtid */
- 	/* NEW TUPLE xl_heap_header AND TUPLE DATA FOLLOWS AT END OF STRUCT */
- } xl_heap_update;
- 
- #define SizeOfHeapUpdate	(offsetof(xl_heap_update, new_all_visible_cleared) + sizeof(bool))
- 
- /*
-  * This is what we need to know about vacuum page cleanup/redirect
-  *
-  * The array of OffsetNumbers following the fixed part of the record contains:
-  *	* for each redirected item: the item offset, then the offset redirected to
-  *	* for each now-dead item: the item offset
-  *	* for each now-unused item: the item offset
-  * The total number of OffsetNumbers is therefore 2*nredirected+ndead+nunused.
-  * Note that nunused is not explicitly stored, but may be found by reference
-  * to the total record length.
-  */
- typedef struct xl_heap_clean
- {
- 	RelFileNode node;
- 	BlockNumber block;
- 	TransactionId latestRemovedXid;
- 	uint16		nredirected;
- 	uint16		ndead;
- 	/* OFFSET NUMBERS FOLLOW */
- } xl_heap_clean;
- 
- #define SizeOfHeapClean (offsetof(xl_heap_clean, ndead) + sizeof(uint16))
- 
- /*
-  * Cleanup_info is required in some cases during a lazy VACUUM.
-  * Used for reporting the results of HeapTupleHeaderAdvanceLatestRemovedXid()
-  * see vacuumlazy.c for full explanation
-  */
- typedef struct xl_heap_cleanup_info
- {
- 	RelFileNode node;
- 	TransactionId latestRemovedXid;
- } xl_heap_cleanup_info;
- 
- #define SizeOfHeapCleanupInfo (sizeof(xl_heap_cleanup_info))
- 
- /* This is for replacing a page's contents in toto */
- /* NB: this is used for indexes as well as heaps */
- typedef struct xl_heap_newpage
- {
- 	RelFileNode node;
- 	ForkNumber	forknum;
- 	BlockNumber blkno;			/* location of new page */
- 	/* entire page contents follow at end of record */
- } xl_heap_newpage;
- 
- #define SizeOfHeapNewpage	(offsetof(xl_heap_newpage, blkno) + sizeof(BlockNumber))
- 
- /* This is what we need to know about lock */
- typedef struct xl_heap_lock
- {
- 	xl_heaptid	target;			/* locked tuple id */
- 	TransactionId locking_xid;	/* might be a MultiXactId not xid */
- 	bool		xid_is_mxact;	/* is it? */
- 	bool		shared_lock;	/* shared or exclusive row lock? */
- } xl_heap_lock;
- 
- #define SizeOfHeapLock	(offsetof(xl_heap_lock, shared_lock) + sizeof(bool))
- 
- /* This is what we need to know about in-place update */
- typedef struct xl_heap_inplace
- {
- 	xl_heaptid	target;			/* updated tuple id */
- 	/* TUPLE DATA FOLLOWS AT END OF STRUCT */
- } xl_heap_inplace;
- 
- #define SizeOfHeapInplace	(offsetof(xl_heap_inplace, target) + SizeOfHeapTid)
- 
- /* This is what we need to know about tuple freezing during vacuum */
- typedef struct xl_heap_freeze
- {
- 	RelFileNode node;
- 	BlockNumber block;
- 	TransactionId cutoff_xid;
- 	/* TUPLE OFFSET NUMBERS FOLLOW AT THE END */
- } xl_heap_freeze;
- 
- #define SizeOfHeapFreeze (offsetof(xl_heap_freeze, cutoff_xid) + sizeof(TransactionId))
- 
- /* This is what we need to know about setting a visibility map bit */
- typedef struct xl_heap_visible
- {
- 	RelFileNode node;
- 	BlockNumber block;
- 	TransactionId cutoff_xid;
- } xl_heap_visible;
- 
- #define SizeOfHeapVisible (offsetof(xl_heap_visible, cutoff_xid) + sizeof(TransactionId))
- 
- extern void HeapTupleHeaderAdvanceLatestRemovedXid(HeapTupleHeader tuple,
- 									   TransactionId *latestRemovedXid);
- 
  /* HeapTupleHeader functions implemented in utils/time/combocid.c */
  extern CommandId HeapTupleHeaderGetCmin(HeapTupleHeader tup);
  extern CommandId HeapTupleHeaderGetCmax(HeapTupleHeader tup);
--- 526,531 ----
*** a/src/include/access/printtup.h
--- b/src/include/access/printtup.h
***************
*** 14,19 ****
--- 14,21 ----
  #ifndef PRINTTUP_H
  #define PRINTTUP_H
  
+ #include "access/tupdesc.h"
+ #include "tcop/dest.h"
  #include "utils/portal.h"
  
  extern DestReceiver *printtup_create_DR(CommandDest dest);
*** a/src/include/access/reloptions.h
--- b/src/include/access/reloptions.h
***************
*** 19,25 ****
  #ifndef RELOPTIONS_H
  #define RELOPTIONS_H
  
! #include "access/htup.h"
  #include "nodes/pg_list.h"
  
  /* types supported by reloptions */
--- 19,26 ----
  #ifndef RELOPTIONS_H
  #define RELOPTIONS_H
  
! #include "access/tupbasics.h"
! #include "access/tupdesc.h"
  #include "nodes/pg_list.h"
  
  /* types supported by reloptions */
*** a/src/include/access/relscan.h
--- b/src/include/access/relscan.h
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/itup.h"
  #include "access/tupdesc.h"
  
*** a/src/include/access/rewriteheap.h
--- b/src/include/access/rewriteheap.h
***************
*** 13,19 ****
  #ifndef REWRITE_HEAP_H
  #define REWRITE_HEAP_H
  
! #include "access/htup.h"
  #include "utils/relcache.h"
  
  /* struct definition is private to rewriteheap.c */
--- 13,19 ----
  #ifndef REWRITE_HEAP_H
  #define REWRITE_HEAP_H
  
! #include "access/tupbasics.h"
  #include "utils/relcache.h"
  
  /* struct definition is private to rewriteheap.c */
*** /dev/null
--- b/src/include/access/tupbasics.h
***************
*** 0 ****
--- 1,77 ----
+ /*-------------------------------------------------------------------------
+  * tupbasics.h
+  * 		POSTGRES tuple struct forward declarations
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  *
+  * src/include/access/tupbasics.h
+  *-------------------------------------------------------------------------
+  */
+ #ifndef TUPBASICS_H
+ #define TUPBASICS_H
+ 
+ #include "storage/itemptr.h"
+ 
+ /* typedefs and forward declarations for structs defined in htupdata.h */
+ 
+ typedef struct HeapTupleHeaderData HeapTupleHeaderData;
+ 
+ typedef HeapTupleHeaderData *HeapTupleHeader;
+ 
+ typedef struct MinimalTupleData MinimalTupleData;
+ 
+ typedef MinimalTupleData *MinimalTuple;
+ 
+ #define HEAPTUPLESIZE	MAXALIGN(sizeof(HeapTupleData))
+ 
+ /*
+  * HeapTupleData is an in-memory data structure that points to a tuple.
+  *
+  * There are several ways in which this data structure is used:
+  *
+  * * Pointer to a tuple in a disk buffer: t_data points directly into the
+  *	 buffer (which the code had better be holding a pin on, but this is not
+  *	 reflected in HeapTupleData itself).
+  *
+  * * Pointer to nothing: t_data is NULL.  This is used as a failure indication
+  *	 in some functions.
+  *
+  * * Part of a palloc'd tuple: the HeapTupleData itself and the tuple
+  *	 form a single palloc'd chunk.  t_data points to the memory location
+  *	 immediately following the HeapTupleData struct (at offset HEAPTUPLESIZE).
+  *	 This is the output format of heap_form_tuple and related routines.
+  *
+  * * Separately allocated tuple: t_data points to a palloc'd chunk that
+  *	 is not adjacent to the HeapTupleData.	(This case is deprecated since
+  *	 it's difficult to tell apart from case #1.  It should be used only in
+  *	 limited contexts where the code knows that case #1 will never apply.)
+  *
+  * * Separately allocated minimal tuple: t_data points MINIMAL_TUPLE_OFFSET
+  *	 bytes before the start of a MinimalTuple.	As with the previous case,
+  *	 this can't be told apart from case #1 by inspection; code setting up
+  *	 or destroying this representation has to know what it's doing.
+  *
+  * t_len should always be valid, except in the pointer-to-nothing case.
+  * t_self and t_tableOid should be valid if the HeapTupleData points to
+  * a disk buffer, or if it represents a copy of a tuple on disk.  They
+  * should be explicitly set invalid in manufactured tuples.
+  */
+ typedef struct HeapTupleData
+ {
+ 	uint32		t_len;			/* length of *t_data */
+ 	ItemPointerData t_self;		/* SelfItemPointer */
+ 	Oid			t_tableOid;		/* table the tuple came from */
+ 	HeapTupleHeader t_data;		/* -> tuple header and data */
+ } HeapTupleData;
+ 
+ typedef HeapTupleData *HeapTuple;
+ 
+ /*
+  * Accessor macros to be used with HeapTuple pointers.
+  */
+ #define HeapTupleIsValid(tuple) PointerIsValid(tuple)
+ 
+ 
+ #endif /* TUPBASICS_H */
*** a/src/include/access/tupconvert.h
--- b/src/include/access/tupconvert.h
***************
*** 14,20 ****
  #ifndef TUPCONVERT_H
  #define TUPCONVERT_H
  
! #include "access/htup.h"
  
  
  typedef struct TupleConversionMap
--- 14,21 ----
  #ifndef TUPCONVERT_H
  #define TUPCONVERT_H
  
! #include "access/tupbasics.h"
! #include "access/tupdesc.h"
  
  
  typedef struct TupleConversionMap
*** a/src/include/catalog/indexing.h
--- b/src/include/catalog/indexing.h
***************
*** 15,21 ****
  #ifndef INDEXING_H
  #define INDEXING_H
  
! #include "access/htup.h"
  #include "utils/relcache.h"
  
  /*
--- 15,21 ----
  #ifndef INDEXING_H
  #define INDEXING_H
  
! #include "access/tupbasics.h"
  #include "utils/relcache.h"
  
  /*
*** a/src/include/commands/explain.h
--- b/src/include/commands/explain.h
***************
*** 14,19 ****
--- 14,20 ----
  #define EXPLAIN_H
  
  #include "executor/executor.h"
+ #include "lib/stringinfo.h"
  
  typedef enum ExplainFormat
  {
*** a/src/include/commands/portalcmds.h
--- b/src/include/commands/portalcmds.h
***************
*** 15,21 ****
--- 15,23 ----
  #define PORTALCMDS_H
  
  #include "nodes/parsenodes.h"
+ #include "nodes/plannodes.h"
  #include "utils/portal.h"
+ #include "tcop/dest.h"
  
  
  extern void PerformCursorOpen(PlannedStmt *stmt, ParamListInfo params,
*** a/src/include/commands/prepare.h
--- b/src/include/commands/prepare.h
***************
*** 14,19 ****
--- 14,20 ----
  #define PREPARE_H
  
  #include "commands/explain.h"
+ #include "datatype/timestamp.h"
  #include "utils/plancache.h"
  
  /*
*** a/src/include/commands/tablecmds.h
--- b/src/include/commands/tablecmds.h
***************
*** 14,20 ****
  #ifndef TABLECMDS_H
  #define TABLECMDS_H
  
! #include "access/htup.h"
  #include "nodes/parsenodes.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
--- 14,20 ----
  #ifndef TABLECMDS_H
  #define TABLECMDS_H
  
! #include "access/tupbasics.h"
  #include "nodes/parsenodes.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
*** a/src/include/commands/typecmds.h
--- b/src/include/commands/typecmds.h
***************
*** 14,20 ****
  #ifndef TYPECMDS_H
  #define TYPECMDS_H
  
! #include "access/htup.h"
  #include "nodes/parsenodes.h"
  
  
--- 14,20 ----
  #ifndef TYPECMDS_H
  #define TYPECMDS_H
  
! #include "access/tupbasics.h"
  #include "nodes/parsenodes.h"
  
  
*** a/src/include/commands/vacuum.h
--- b/src/include/commands/vacuum.h
***************
*** 14,23 ****
  #ifndef VACUUM_H
  #define VACUUM_H
  
! #include "access/htup.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
  #include "nodes/parsenodes.h"
  #include "storage/buf.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
--- 14,24 ----
  #ifndef VACUUM_H
  #define VACUUM_H
  
! #include "access/tupbasics.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
  #include "nodes/parsenodes.h"
+ #include "storage/block.h"
  #include "storage/buf.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
*** a/src/include/executor/spi.h
--- b/src/include/executor/spi.h
***************
*** 15,20 ****
--- 15,22 ----
  
  #include "nodes/parsenodes.h"
  #include "utils/portal.h"
+ #include "utils/relcache.h"
+ #include "utils/snapshot.h"
  
  
  typedef struct SPITupleTable
*** a/src/include/executor/tuptable.h
--- b/src/include/executor/tuptable.h
***************
*** 14,20 ****
  #ifndef TUPTABLE_H
  #define TUPTABLE_H
  
! #include "access/htup.h"
  #include "storage/buf.h"
  
  /*----------
--- 14,22 ----
  #ifndef TUPTABLE_H
  #define TUPTABLE_H
  
! #include "access/tupbasics.h"
! #include "access/tupdesc.h"
! #include "nodes/nodes.h"
  #include "storage/buf.h"
  
  /*----------
*** a/src/include/funcapi.h
--- b/src/include/funcapi.h
***************
*** 17,22 ****
--- 17,23 ----
  #define FUNCAPI_H
  
  #include "fmgr.h"
+ #include "access/tupbasics.h"
  #include "access/tupdesc.h"
  #include "executor/executor.h"
  #include "executor/tuptable.h"
*** a/src/include/nodes/execnodes.h
--- b/src/include/nodes/execnodes.h
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/tupbasics.h"
  #include "executor/instrument.h"
  #include "nodes/params.h"
  #include "nodes/plannodes.h"
